#ifndef DUNE_CODEGEN_COMMON_VECTORCLASS_HH
#define DUNE_CODEGEN_COMMON_VECTORCLASS_HH


template<typename T>
struct base_floatingpoint
{};

#ifdef ENABLE_COUNTER
#if HAVE_DUNE_OPCOUNTER
#include<dune/opcounter/vectorclass.hh>

template<typename F, int size>
struct base_floatingpoint<OpCounter::impl::OpCounterVector<F, size>>
{
  using value = OpCounter::OpCounter<F>;
};


#else
#error "dune-opcounter is needed for opcounted vector types"
#endif
#else
#include<dune/codegen/vectorclass/vectorclass.h>
#include<dune/codegen/vectorclass/vectormath_exp.h>
#include<dune/codegen/vectorclass/vectormath_hyp.h>
#include<dune/codegen/vectorclass/vectormath_trig.h>

template<>
struct base_floatingpoint<Vec2d>
{
  using value = double;
};

template<>
struct base_floatingpoint<Vec4f>
{
  using value = float;
};


#if MAX_VECTOR_SIZE >= 256
template<>
struct base_floatingpoint<Vec4d>
{
  using value = double;
};

template<>
struct base_floatingpoint<Vec8f>
{
  using value = float;
};
#endif

#if MAX_VECTOR_SIZE >= 512
template<>
struct base_floatingpoint<Vec8d>
{
  using value = double;
};

template<>
struct base_floatingpoint<Vec16f>
{
  using value = float;
};
#endif

#endif

#endif // DUNE_CODEGEN_COMMON_VECTORCLASS_HH
