from dune.codegen.error import CodegenError
from dune.codegen.generation import quadrature_mixin
from dune.codegen.pdelab.quadrature import GenericQuadratureMixin
from dune.codegen.blockstructured.tools import name_point_in_macro
import pymbolic.primitives as prim


@quadrature_mixin("blockstructured")
class BlockstructuredQuadratureMixin(GenericQuadratureMixin):
    def quadrature_position_in_micro(self, index=None):
        return GenericQuadratureMixin.quadrature_position(self, index)

    def quadrature_position_in_macro(self, index=None):
        original = self.quadrature_position_in_micro(index)
        qp = prim.Variable(name_point_in_macro(original, self), )
        if index is not None:
            return prim.Subscript(qp, (index,))
        else:
            return qp

    def quadrature_position(self, index=None):
        raise CodegenError('Decide if the quadrature point is in the macro or micro element')
